import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component, createRef } from 'react';
import classnames from 'classnames';
import PropTypes from 'prop-types';
import withStyles from '@material-ui/core/styles/withStyles';
import { lazyLoadImages } from './utils/lazyLoadImages';
export var styles = function styles(theme) {
  return {
    inline: {
      display: 'inline'
    },
    block: {
      display: 'block'
    },
    root: {
      '& .rsf-presized-img': {
        position: 'relative',
        '& img': {
          position: 'absolute',
          height: '100%',
          width: '100%',
          top: 0,
          left: 0
        }
      },
      '& img[data-rsf-lazy]': {
        visibility: 'hidden'
      }
    }
  };
};
/**
 * A container for HTML blob content from a CMS.  Content is dangerously inserted into the DOM.
 * Pass the html as a string as the child of this component. Additional props are spread to the
 * rendered span element.
 */

var CmsSlot = (_dec = withStyles(styles, {
  name: 'RSFCmsSlot'
}), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(CmsSlot, _Component);

  function CmsSlot(_ref) {
    var _this;

    var lazyLoadImages = _ref.lazyLoadImages;

    _classCallCheck(this, CmsSlot);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CmsSlot).call(this));

    if (lazyLoadImages) {
      _this.el = createRef();
    }

    return _this;
  }

  _createClass(CmsSlot, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.lazyLoadImages) {
        lazyLoadImages(this.el.current);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.props.lazyLoadImages) {
        lazyLoadImages(this.el.current);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _classnames;

      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          classes = _this$props.classes,
          inline = _this$props.inline,
          lazyLoadImages = _this$props.lazyLoadImages,
          others = _objectWithoutProperties(_this$props, ["children", "className", "classes", "inline", "lazyLoadImages"]);

      return children ? React.createElement("span", _extends({}, others, {
        ref: this.el,
        className: classnames(className, classes.root, (_classnames = {}, _defineProperty(_classnames, classes.inline, inline), _defineProperty(_classnames, classes.block, !inline), _classnames)),
        dangerouslySetInnerHTML: {
          __html: children
        }
      })) : null;
    }
  }]);

  return CmsSlot;
}(Component), _defineProperty(_class2, "proptypes", {
  /**
   * Use inline prop to use display:inline style
   */
  inline: PropTypes.boolean,

  /**
   * Set to true to lazy load images that have been preprocessed with `$.lazyLoadImages()`.
   */
  lazyLoadImages: PropTypes.boolean
}), _defineProperty(_class2, "defaultProps", {
  lazyLoadImages: false
}), _temp)) || _class);
export { CmsSlot as default };
//# sourceMappingURL=CmsSlot.js.map